
/**
 * Created by IntelliJ IDEA.
 * Author: Alexandre Koubenski
 *
 *        
 *       .
 *
 * Date: 09.12.2005
 * Time: 9:52:28
 */
public class Huffman {
    //    
    static int[] prs = new int[Code.probs.length];

    /**
     *  ,   .
     * @param n -  
     */
    public static void huffman(int n) {
        if (n == 2) {
            //   -    
            Code.codes[0] = new Code((long)0, (byte)1);
            Code.codes[1] = new Code((long)1, (byte)1);
        } else {
            //           
            int j = up(n, prs[n-2] + prs[n-1]);
            //      
            huffman(n-1);
            //      j
            down(n, j);
        }
    }

    /**
     *          
     * @param n -  
     * @param p -  
     * @return  -     
     */
    private static int up(int n, int p) {
        int j = n-1;   //     
        while (j >= 1) {
            if (prs[j-1] < p) {
                //   
                prs[j] = prs[j-1];
                j--;
            } else {
                //    
                break;
            }
        }
        //      
        prs[j] = p;
        return j;
    }

    /**
     *    
     * @param n -  
     * @param j -  
     */
    private static void down(int n, int j) {
        Code c = new Code(Code.codes[j]);  //  
        for (int i = j; i < n-2; i++) {    //     
            Code.codes[i].assign(Code.codes[i+1]);
        }
        //    
        c.len++;
        c.code <<= 1;
        Code.codes[n-2] = new Code(c);
        c.code++;
        Code.codes[n-1] = new Code(c);
    }

    /**
     *        
     * @param args
     */
    public static void main(String[] args) {
        //    
        for (int i = 0; i < prs.length; i++) {
            prs[i] = Code.probs[i];
        }
        //  
        huffman(Code.chars.length);
        //  
        Code.outCodes();
    }
}
